diff -r -c -b -B -N cosmomc/source/paramdef.F90 cosmomc_sampler/source/paramdef.F90
*** cosmomc/source/paramdef.F90	2009-09-18 17:33:04.000000000 +0200
--- cosmomc_sampler/source/paramdef.F90	2009-10-28 18:38:26.467004511 +0100
***************
*** 1,16 ****
  !Defines a parameterization, computes likelihoods and defined proposal density
  !Change this file to change these things, and MPI updating
- !The Cls are computed using routines defined in the CMB_Cls module
  
  module ParamDef
    !module defines a parameterization, and works out power spectra
!  use CMB_Cls
!  use cmbtypes
!  use cmbdata
   use Random
   use settings
   implicit none
  
   Type ParamSet
      real P(num_params)
      Type(ParamSetInfo) Info
--- 1,20 ----
  !Defines a parameterization, computes likelihoods and defined proposal density
  !Change this file to change these things, and MPI updating
  
  module ParamDef
    !module defines a parameterization, and works out power spectra
! ! use cmbtypes
! ! use cmbdata
   use Random
   use settings
+ 
   implicit none
  
+  Type ParamSetInfo  
+     integer :: infoInt
+     real :: infoReal
+  end Type ParamSetInfo
+ 
   Type ParamSet
      real P(num_params)
      Type(ParamSetInfo) Info
***************
*** 135,141 ****
          
          Ini_fail_on_not_found = .false.
  
!         call CMB_Initialize(Params%Info)
  
          prop_mat = Ini_Read_String('propose_matrix')
          has_propose_matrix = prop_mat /= ''
--- 139,145 ----
          
          Ini_fail_on_not_found = .false.
  
! !        call CMB_Initialize(Params%Info)
  
          prop_mat = Ini_Read_String('propose_matrix')
          has_propose_matrix = prop_mat /= ''
***************
*** 359,400 ****
  end subroutine SetProposeMatrix
  
  
- 
-  
-   subroutine WriteCMBParams(CMB,Theory,mult,like, with_data)     
-      Type (CosmoTheory) Theory 
-      real, intent(in) :: mult, like
-      logical, intent(in), optional :: with_data
-      Type(ParamSet) P
-      Type(CMBParams) CMB
- 
- 
-      call CMBParamsToParams(CMB,P%P)
- 
-      P%Info%Theory = Theory
-      if (present(with_data)) then
-       if (with_data) then
-       call WriteParamsAndDat(P, mult,like)
-       else
-       call WriteParams(P, mult,like)
-       end if
-      else
-       call WriteParams(P, mult,like)
-      end if
- 
-   end subroutine WriteCMBParams
-    
    subroutine WriteIndepSample(P, like)
      Type(ParamSet) P
      real like
!     Type(CMBParams) C
      if (indepfile_handle ==0) return
!     call ParamsToCMBParams(P%P,C)
!     call WriteModel(indepfile_handle, C,P%Info%Theory,like)
     end subroutine WriteIndepSample
  
  
     subroutine AddMPIParams(P,like, checkpoint_start)     
       real, intent(in) ::like
       real P(:)
       logical, intent(in), optional :: checkpoint_start
--- 363,380 ----
  end subroutine SetProposeMatrix
  
   
    subroutine WriteIndepSample(P, like)
      Type(ParamSet) P
      real like
! 
      if (indepfile_handle ==0) return
! 
     end subroutine WriteIndepSample
  
  
     subroutine AddMPIParams(P,like, checkpoint_start)     
+      use IO
+      use MAtrixUtils
       real, intent(in) ::like
       real P(:)
       logical, intent(in), optional :: checkpoint_start
***************
*** 729,734 ****
--- 709,715 ----
  #ifdef MPI
  
   subroutine CheckLimitsConverge(L)
+    use IO
    !Check limits from last half chains agree well enough across chains to be confident of result
    !Slowly explored tails will cause problems (long time till stops)
    Type(TList_RealArr), intent(in) :: L
diff -r -c -b -B -N cosmomc/source/params_EXT.f90 cosmomc_sampler/source/params_EXT.f90
*** cosmomc/source/params_EXT.f90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_sampler/source/params_EXT.f90	2009-10-28 17:57:12.524467968 +0100
***************
*** 0 ****
--- 1,63 ----
+    subroutine SetParamNames(Names)
+     use settings
+     use ParamNames
+     Type(TParamNames) :: Names
+  
+     if (generic_mcmc) then
+      Names%nnames=0
+      if (Feedback>0) write (*,*) 'edit SetParamNames in params_CMB.f90 if you want to use named params'
+ !     call ParamNames_init(Names, './params_EXT.paramnames')
+   end if
+ end subroutine SetParamNames
+ 
+ 
+   subroutine WriteParams(P, mult, like)
+      use settings 
+      use ParamDef
+      use IO
+      implicit none
+      Type(ParamSet) P
+      real, intent(in) :: mult, like
+      real r10
+      real, allocatable :: output_array(:)
+   
+     if (outfile_handle ==0) return
+   
+     if (generic_mcmc) then
+ 
+       call IO_OutputChainRow(outfile_handle, mult, like, P%P)
+      
+     else
+     
+        stop
+      
+     end if
+ 
+   end  subroutine WriteParams
+ 
+ 
+ 
+ 
+   subroutine WriteParamsAndDat(P, mult, like)
+      use settings
+      use ParamDef
+      use IO
+      implicit none
+     Type(ParamSet) P
+     real, intent(in) :: mult, like
+     character(LEN =30) fmt
+     real r10
+     real,allocatable :: output_array(:)
+        
+     if (outfile_handle ==0) return
+ 
+     allocate(output_array(num_real_params))
+     output_array(1:num_real_params) =  P%P(1:num_real_params)
+      
+     call IO_OutputChainRow(outfile_handle, mult, like, output_array)
+     deallocate(output_array)
+     
+   end  subroutine WriteParamsAndDat
+ 
+ 
+  
diff -r -c -b -B -N cosmomc/source/postprocess.f90 cosmomc_sampler/source/postprocess.f90
*** cosmomc/source/postprocess.f90	2009-10-19 20:45:07.000000000 +0200
--- cosmomc_sampler/source/postprocess.f90	2009-10-28 17:35:49.788682234 +0100
***************
*** 7,15 ****
  
  module posthoc
    use settings
-   use cmbtypes
-   use CMB_Cls
-   use cmbdata
    use CalcLike
    implicit none
  
--- 7,12 ----
***************
*** 71,287 ****
     subroutine postprocess(InputFile)
          use IO
          character(LEN=*), intent(INOUT):: InputFile
-         Type(CMBParams) LastCMB,CMB, newCMB
-         Type(CosmoTheory) Theory, CorrectTheory
-         Type(ParamSetInfo) Info
-         real Cls(lmax,num_cls), truelike,mult,like
-         real weight_min, weight_max, mult_sum, mult_ratio, mult_max,weight
  
!         real max_like, max_truelike
!         integer error,num, debug
!         character (LEN=120) :: post_root
!         real Params(num_params)
!         integer infile_handle, outdata_handle
! 
!         flush_write = .false.
!         weight_min= 1e30
!         weight_max = -1e30
!         mult_sum = 0
!         mult_ratio = 0
!         mult_max = -1e30
!         max_like = 1e30
! 
!         max_truelike =1e30
! 
!         debug = 0
!         Info%Theory%Sn_LogLike = 0
!         Info%Theory%HST_LogLike = 0
!         Info%Theory%BAO_LogLike = 0
! 
!         infile_handle = 0
!         Temperature = PostParams%redo_temperature 
! 
!         if (Feedback>0 .and. PostParams%redo_change_like_only) &
!               write (*,*) 'Warning: only changing likelihoods not weights'
! 
!         if (PostParams%redo_datafile /= '') InputFile = PostParams%redo_datafile
! 
!         if (PostParams%redo_from_text) then
! 
!          infile_handle = IO_OpenChainForRead(trim(InputFile)//'.txt')
!          
!          if (.not. PostParams%redo_theory) write (*,*) '**You probably want to set redo_theory**'
!          if (.not. PostParams%redo_cls .and. Use_CMB) write (*,*) '**You probably want to set redo_cls**'
!          if (.not. PostParams%redo_pk .and. Use_mpk) write (*,*) '**You probably want to set redo_pk**'
! 
!          if (PostParams%redo_thin>1) write (*,*) 'redo_thin only OK with redo_from_text if input weights are 1'
! 
!         else
!          infile_handle = IO_OpenDataForRead(trim(InputFile)//'.data')
!         end if
! 
!          
!         if (PostParams%redo_outroot == '') then
!           post_root = trim(ExtractFilePath(InputFile))//'post_'// trim(ExtractFileName(InputFile))
!         else
!           post_root = PostParams%redo_outroot
!           if (instance /= 0) post_root = numcat(trim(post_root)//'_',instance)
!         end if
! 
!         if (Feedback > 0) then
!           if (PostParams%redo_from_text) then
!            write (*,*) 'reading from: ' //  trim(InputFile)//'.txt'
!           else
!            write (*,*) 'reading from: ' //  trim(InputFile)//'.data'
!           end if
!            write (*,*) 'writing to: ' // trim(post_root)//'.*'
!         end if
! 
!         write (*,*) 'Using temperature: ', Temperature
! 
!         outfile_handle = IO_OutputOpenForWrite(trim(post_root)//'.txt')
!         
!         outdata_handle = IO_DataOpenForWrite(trim(post_root)//'.data')
!      
!         num = 0
!         do
! 
!         if (PostParams%redo_from_text) then
!           error = 0
!           if (.not. IO_ReadChainRow(infile_handle, mult, like, Params, num_params)) exit
!           call ParamsToCMBParams(Params, CMB)
! 
!         else
!           call ReadModel(infile_handle,CMB,Theory,mult,like, error)
!         end if
! 
!            
!         if (error ==1) then
!           if (num==0) call MpiStop('Error reading data file.')
! 
!           exit
!         end if
!         num=num+1
!         if (num>PostParams%redo_skip .and. mod(num,PostParams%redo_thin) == 0) then
!      
!         LastCMB = CMB
! 
!         newCMB = CMB  
!         if (PostParams%redo_theory) then
!     
!          call GetClsInfo(newCMB, CorrectTheory, error, PostParams%redo_cls, PostParams%redo_pk)
!     
!          if (PostParams%redo_cls) then
!             Theory%cl = CorrectTheory%cl
!             Theory%cl_tensor = CorrectTheory%cl_tensor
!             !!In last version redo_cls just for going to higher l on temperature
! 
!          end if
!   
!          if (PostParams%redo_pk) then
!             Theory%sigma_8 = CorrectTheory%sigma_8
!             Theory%Matter_Power = CorrectTheory%Matter_Power
!          end if
! 
!          Theory%Age = CorrectTheory%Age
!      
!         else
!           error = 0
!         end if
! 
! 
!           CorrectTheory = Theory
! 
! 
!          if (error ==0) then
!  
!            if (PostParams%redo_like) then
!                
! 
!               if (Use_LSS .and. CorrectTheory%sigma_8==0) &
!                  call MpiStop('Matter power/sigma_8 have not been computed. Use redo_theory and redo_pk.')
! 
! 
!               call ClsFromTheoryData(CorrectTheory, newCMB, Cls)
!               Info%Theory = CorrectTheory
!             
!               if (any(Cls(2:lmax,1) < 0)) then
!                  write (*,*) 'WARNING: bad model with C_l < 0 being rejected'
!                  write (*,*) 'in '//trim(InputFile)
!                  !This shouldn't happen. 
!                  !But good sanity check, esp when playing around with extended models
!                  !Think have fixed problems with Om_k \sim -7e-4, w\sim -0.7.
!                  write (*,*) newCMB
!                  write (*,*)
!                  truelike = logZero
!               else
!                truelike = GetLogLikePost(newCMB, Info, Cls,.true.)
!               end if
!               if (truelike == logZero) then
!                weight = 0
!               else
!                if (PostParams%redo_add) truelike = like + truelike
! 
!                weight = exp(like-truelike+PostParams%redo_likeoffset)
!               end if
!            
!              if (.not. PostParams%redo_change_like_only)  mult = mult*weight
!            else
!               truelike = like
!               weight = 1
!            end if
! 
! 
!            max_like = min(max_like,like)
! 
!            max_truelike = min(max_truelike,truelike)
! 
!            mult_ratio = mult_ratio + weight
!            mult_sum = mult_sum + mult
!           
!            if (mult /= 0) then        
!             call WriteCMBParams(newCMB, CorrectTheory, mult, truelike,txt_theory)
!             call WriteModel(outdata_handle, newCMB, CorrectTheory,truelike,mult)
! 
!            else 
! 
!             if (Feedback >1 ) write (*,*) 'Zero weight: new like = ', truelike
!            end if
!           
!            if (Feedback > 1) write (*,*) 'done ', num, 'mult= ', mult,' weight = ', weight
!            weight_max = max(weight,weight_max)       
!            weight_min = min(weight,weight_min)
!            mult_max = max(mult_max,mult)
! 
!         end if
!         end if
!         
!         end do
! 
!         call IO_Close(infile_handle)
!         call IO_Close(outfile_handle)
!         call IO_DataCloseWrite(outdata_handle)
!       
!         num = (num - PostParams%redo_skip) / PostParams%redo_thin
!         if (Feedback>0) then 
!            write(*,*) 'finished. Processed ',num,' models'
!            write (*,*) 'max weight= ',weight_max, ' min weight = ',weight_min
!            write (*,*) 'mean mult  = ', mult_sum/num
!            write (*,*) 'mean importance weight (approx evidence ratio) = ',mult_ratio/num
!            write (*,*) 'effective number of samples =',mult_sum/mult_max
!            write (*,*) 'Best redo_likeoffset = ',max_truelike - max_like
!          end if
!         
!         if ((mult_ratio < 1e-6 .or. mult_ratio > 1e8) & 
! 
!             .and. .not.PostParams%redo_change_like_only) then
! 
!          write (*,*) 'WARNING: use redo_likeoffset to rescale likelihoods'
!         end if
! 
! 
! 
!         return
  
          end subroutine postprocess
  
--- 68,75 ----
     subroutine postprocess(InputFile)
       use IO
       character(LEN=*), intent(INOUT):: InputFile
  
!      stop 'postprocess not implemented!'
          
     end subroutine postprocess
  
diff -r -c -b -B -N cosmomc/source/settings.f90 cosmomc_sampler/source/settings.f90
*** cosmomc/source/settings.f90	2009-10-22 11:33:09.000000000 +0200
--- cosmomc_sampler/source/settings.f90	2009-10-28 17:36:04.748706471 +0100
***************
*** 43,49 ****
  
    real, parameter :: cl_norm = 1e-10 !units for As
  
!   logical, parameter ::  generic_mcmc= .false. 
      !set to true to not call CAMB, etc.
      !write GenericLikelihoodFunction in calclike.f90   
  
--- 43,49 ----
  
    real, parameter :: cl_norm = 1e-10 !units for As
  
!   logical, parameter ::  generic_mcmc= .true. 
      !set to true to not call CAMB, etc.
      !write GenericLikelihoodFunction in calclike.f90   
  
diff -r -c -b -B -N cosmomc/source/wrapper.f90 cosmomc_sampler/source/wrapper.f90
*** cosmomc/source/wrapper.f90	1970-01-01 01:00:00.000000000 +0100
--- cosmomc_sampler/source/wrapper.f90	2009-04-30 16:51:19.474271389 +0200
***************
*** 0 ****
--- 1,23 ----
+ module wrapper
+   use paramdef, only : paramset, paramsetinfo
+   implicit none
+   
+ 
+ contains
+ 
+ 
+   subroutine AcceptReject(accpt, CurParams, Trial)
+     logical, intent(in) :: accpt
+     Type(ParamSetInfo) CurParams, Trial
+     
+     
+     if (accpt) then
+        print *,'accepted'
+     else
+        print *,'rejected'
+     end if
+     
+   end subroutine AcceptReject
+ 
+ end module wrapper
+ 
